
/*
tutorial_#6-05

=====================
Six Online Tutorials:
=====================

The tutorials online propose ideas and approaches, which allow the user to problematize and then practice to do something to use for their own purposes.
Describes the stages of construction of some systems to help the reader, step by step, to learn to do something, to build patchs be used effectively in the performance.
Examples are some ideas to change, expand, or start from scratch using the same ideas or the same solutions and then realize their control systems.

=====================
ONLINE TUTORIAL #6
6. "eSpace" (by E.Francioni) - example of realtime spatialization of multichannel signals.
=====================

In this tutorial_#6-05 the signal is "conducted" freely with the use of the mouse inside the Joystick.
N.B. For successful execution of the algorithm with spatial 4-channel [nchnls = 4] is necessary to interface a sound card to 4 output channels and one input channel; alternatively it is important to keep nchnls = 2.

Some observations:
     for orchestra
     - Variables kx and ky are managed by the Controller present in the Widgets Panel passing in the orchestra (with inValue) values of x and y for location / spatial signal;

     in the Widgets panel
     - We start instr 1 with Button "Joystick";
     - We can guide the conduct of the signal in space quadraphonic with the mouse inside the Controller.

*/

<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

; header
sr		=	44100
ksmps		=	64
nchnls		=	2
;nchnls		=	4
0dbfs		=	1

;===========================================
	instr 1 	; JOYSTICK
;===========================================

asig		rand	.7			; signal (test)

kx_in	invalue	"x1in"			; import from the graphical interface of the value k of x
ky_in	invalue	"y1in"			; import from the graphical interface of the value k of y

ir		=	2			; conversion value for the Controller in the Widgets Panel
kx	=	(kx_in * ir) - (ir * .5)		; kx conversion values for the Controller
ky	=	(ky_in * ir) - (ir * .5)		; ky conversion values for the Controller

a1, a2, a3, a4 	space	asig, 0, 0, 0, kx, ky	; spatial quadraphonic signal

		outvalue	"x1out", kx	; export graphical interface (display values) values k of x
		outvalue	"y1out", ky	; export graphical interface (display values) values k of y

outch	1, a1, 2, a2, 3, a3, 4, a4		; audio output of four channels
		
		endin
		
</CsInstruments>
<CsScore>
e 3600

</CsScore>
</CsoundSynthesizer><bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>0</x>
 <y>44</y>
 <width>1441</width>
 <height>856</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="background">
  <r>91</r>
  <g>91</g>
  <b>91</b>
 </bgcolor>
 <bsbObject version="2" type="BSBButton">
  <objectName/>
  <x>627</x>
  <y>131</y>
  <width>115</width>
  <height>45</height>
  <uuid>{1cfeefbb-94e9-4445-9f8b-25532a1c60cd}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>Joystick</text>
  <image>/</image>
  <eventLine>i1 0 -1</eventLine>
  <latch>false</latch>
  <latched>false</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>432</x>
  <y>6</y>
  <width>511</width>
  <height>104</height>
  <uuid>{951fe7d4-4247-432d-8eee-6e8889420259}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>CSOUND INSIDE
Enrico Francioni 
"Building Csound-based Systems for Realtime Chamber Music Performance"
TUTORIAL #6-05: "eSpace" (by E.Francioni) - example of realtime spatialization of multichannel signals.</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>14</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>204</r>
   <g>204</g>
   <b>204</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>x1in</objectName>
  <x>405</x>
  <y>183</y>
  <width>551</width>
  <height>551</height>
  <uuid>{5fcb3bd4-1b5c-4b20-a563-b8b9d74ce5c9}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>y1in</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.49001815</xValue>
  <yValue>0.51724138</yValue>
  <type>point</type>
  <pointsize>13</pointsize>
  <fadeSpeed>99.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>202</r>
   <g>2</g>
   <b>2</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>666</x>
  <y>766</y>
  <width>53</width>
  <height>31</height>
  <uuid>{ae6bc59e-dbf9-43aa-a156-f9bef315b309}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>x</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>18</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>87</g>
   <b>121</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>y1out</objectName>
  <x>347</x>
  <y>448</y>
  <width>53</width>
  <height>26</height>
  <uuid>{d2ba19f9-ff0f-4e58-8652-f2c400006a36}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>0.034</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>14</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>x1out</objectName>
  <x>665</x>
  <y>739</y>
  <width>54</width>
  <height>27</height>
  <uuid>{b97596e9-7856-4575-a445-be38e3951cdc}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>-0.020</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>14</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>347</x>
  <y>412</y>
  <width>53</width>
  <height>31</height>
  <uuid>{9068be6f-1cc4-486b-993c-750743b938fa}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>y</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>18</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>87</g>
   <b>121</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>382</x>
  <y>161</y>
  <width>24</width>
  <height>24</height>
  <uuid>{58bb1b38-d1d2-4277-80fc-623dd0f58d90}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Lf</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>954</x>
  <y>160</y>
  <width>24</width>
  <height>24</height>
  <uuid>{02ee7586-a222-4e18-8860-436bcc34cbb8}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Rf</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>382</x>
  <y>732</y>
  <width>24</width>
  <height>24</height>
  <uuid>{7195c6c2-3e95-4428-b6c2-b71ddcb583e7}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Lr</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>955</x>
  <y>733</y>
  <width>24</width>
  <height>24</height>
  <uuid>{3b3de6da-5434-41af-ba3a-26d730e42432}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Rr</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBConsole">
  <objectName/>
  <x>1021</x>
  <y>184</y>
  <width>320</width>
  <height>400</height>
  <uuid>{c99041dc-54d7-4937-98db-4f2ff993c80d}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <font>Courier</font>
  <fontsize>8</fontsize>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 72 179 400 200
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>

<MacGUI>
ioView background {23387, 23387, 23387}
ioButton {627, 131} {115, 45} event 1.000000 "" "Joystick" "/" i1 0 -1
ioText {432, 6} {511, 104} label 0.000000 0.00100 "" center "Arial" 14 {0, 0, 0} {52224, 52224, 52224} nobackground noborder CSOUND INSIDEÂ¬Enrico Francioni Â¬"Building Csound-based Systems for Realtime Chamber Music Performance"Â¬TUTORIAL #6-05: "eSpace" (by E.Francioni) - example of realtime spatialization of multichannel signals.
ioMeter {405, 183} {551, 551} {51712, 512, 512} "x1in" 0.490018 "y1in" 0.517241 point 13 0 mouse
ioText {666, 766} {53, 31} label 0.000000 0.00100 "" center "Lucida Grande" 18 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder x
ioText {347, 448} {53, 26} display 0.034483 0.00100 "y1out" center "Lucida Grande" 14 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder 0.034
ioText {665, 739} {54, 27} display -0.019964 0.00100 "x1out" center "Lucida Grande" 14 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder -0.020
ioText {347, 412} {53, 31} label 0.000000 0.00100 "" center "Lucida Grande" 18 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder y
ioText {382, 161} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 12 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Lf
ioText {954, 160} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 12 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Rf
ioText {382, 732} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 12 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Lr
ioText {955, 733} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 12 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Rr
ioListing {1021, 184} {320, 400}
</MacGUI>
